#ifndef VMACHINE_H
#define VMACHINE_H

#include "tipi.h"

#define LINECNT 			21
#define MAXLINES 			500
#define MAXSNAP 			50

#define VBLCLK 				5493
#define EVBLCLK_NTSC 	5964
#define EVBLCLK_PAL 	7259

#define FPS_NTSC 			60
#define FPS_PAL 			50

extern Byte DbStick1,DbStick2;
extern int Last_Line;
extern int EvblClk;

extern int Master_Clk;
extern int Int_Clk;
extern int H_Clk;
extern Byte ColTab[256];
extern int MState;

extern Byte Rom1[],Rom2[],Rom3[],Rom4[];

extern Byte IntRam[],ExtRam[],ExtRom[];
extern Byte VDCWrite[256];
extern Byte ColorVector[MAXLINES];
extern Byte AudioVector[MAXLINES];
extern Byte *Rom,*oRom;

extern int Frame;
extern int Key2[128];
extern int Key2vCnt;
extern unsigned long Clk_Counter;
extern int CcolFlag;

extern int EnahIrq;
extern int pEndIrq;
extern int UseForEn;
extern long RegionOff;
extern int SprOff;
extern int TweakedAudio;

Byte Read_P2(void);
int SnapLine(int Pos,Byte Reg,int T);
void Ext_Write(Byte Dat,Indirizzo Adr);
Byte Ext_Read(Indirizzo Adr);
void Handle_Vbl(void);
void Handle_Evbl(void);
Byte In_Bus(void);
void Write_P1(Byte D);
Byte Read_T1(void);
void Init_System(void);
void Run(void);

extern struct Resource
{
	int Bank;
	int Debug;
	int Stick[2];
	int Limit;
	int Sound_En;
	int Speed;
	int WSize;
	int FullScreen;
	int ScanLines;
	int Voice;
	int SVolume;
	int VVolume;
	int ExRom;
	int Filter;
	int Euro;
	int OpenB;
	unsigned long Crc;
	char *Window_Title;
	char *ScShot;
} App_Data;

#endif
